/*
 * CBG Ansiterm - kybdr.c
 * Mod Mar 95 to make shifts, up and down, home and end work.
 */

extern char ScreenPage;  /* Use Bit 1 only to toggle between two pages */
extern char *stringptr;
extern char auxchar;
extern char shift, control, alternate, capslock, extendedkybd;
extern char locked;
extern printf();
extern lockmark();
extern putc();
extern sysreq();
extern char kybuf[];
extern char *kybufin, *kybufout;
const kybufsize = 100;
extern int scrolllock;

#define TRC(X) 

extern int cusx, cusy, altcusx, altcusy;

screen_toggle()
{
  int t;
  if (ScreenPage) ScreenPage = 0; else ScreenPage = 2;
  cusout();
  update_screenreg();
  t = cusx; cusx = altcusx; altcusx = t;
  t = cusy; cusy = altcusy; altcusy = t;
}

leaf kybdinit()
{
  int i = 0;
  char x;
  stringptr = 0;
  control = 0;
  extendedkybd = 0;
  shift = 0;
  capslock = 0;
  scrolllock = 0;
  alternate = 0;
  while (++i < 1000000)
  { if (( *(char *) 0xF50001 & 2) == 0) break;
       x = * ( char *) 0xF40001;
  }
  kybufin = &kybuf[0];
  kybufout = &kybuf[0];
 }

char lowkeys[] = {
  0xf9, 0xf9, 0, 0, 0xf3, 0xf3, 0, 0,           // 0
  0, 0, 0xf6, 0xf6, 0x19, 0x09, '|', 0x60,
  0, 0, 0, 0, 0x51, 0x71, 0x21, 0x31,
  0, 0, 0x5a, 0x7a, 0x41, 0x61, 0, 0,
  0, 0, 0x44, 0x64, 0x24, 0x34, 0x23, 0x33,     // 0x10
  32, 32, 0x56, 0x76, 0x54, 0x74, 0, 0
  0x4e, 0x6e, 0x42, 0x62, 0x47, 0x67, 0, 0,
  0, 0, 0x4a, 0x6a, 0x26, 0x37, 0x2A, 0x38,
  0, 0, 0x49, 0x69, 0x29, 0x30, 0x28, 0x39,     // 20
  0x3e, 0x2e, 0x3f, 0x2f, 0x3a, 0x3b, 0, 0,
  0, 0, 0x40, 0x27, 0x7b, 0x5b, 0, 0,
  32,32,0x7d,  0x5d, 0x7e, 0x23, 0, 0,
  '|', '\\', 0, 0, 0, 0, 0, 0,                       // 30
  0, 0, 0x34, '4', 0, 0, 0, 0,
  '0', '0', 0x35, 0x35,   '8', '8', 27, 27,
  0x2b, 0x2b, 0x33, '3',  0x1e, 0x2a, 0, 0,
  0, 0, 0xf7, 0xf7
 }

/* Keys from 0x80 onwards.  Shifted first, then non-shifted. */
char highkeys[] = {
  0, 0, 0xf5, 0xf5, 0xf1, 0xf1, 0xf2, 0xf2,     /* 0x80 */
  0xf0, 0xf0, 0xf8, 0xf8, 0xf4, 0xf4, 0, 0,
  22, 23, 23, 23, 23, 23, 0, 0,
  0, 0, 0x53, 0x73, 0x57, 0x77, 0x22, 0x32,

  0x43, 0x63, 0x58, 0x78, 0x45, 0x65, 0, 0,
  0, 0, 0x46, 0x66, 0x52, 0x72, 0x25, 0x35,
  0, 0, 0x48, 0x68, 0x59, 0x79, '^', 0x36,
  0, 0, 0x4d, 0x6d, 0x55, 0x75, 0, 0,
  0x3c, 0x2c, 0x4b, 0x6b, 0x4f, 0x6f, 0, 0,     // A0
  0, 0, 0x4c, 0x6c, 0x50, 0x70, 0x5f, 0x2d,
  0, 0, 0, 0, 0x2b, 0x3d, 0, 0,
  23, 23, 13, 13, 0, 0, 0, 0,

  0, 0, 0, 0, 0, 0,      0x7f, 0x7f,                 // B0
  '1', '1',  0, 0,        '7', '7', 0, 0,
  '.', '.', '2', '2',  '6', '6', 22, 23,
  0, 0, 0x2d, 0x2d,      '9', '9', 24, 25 
};


/*
 * This routine reads keystrokes into a RAM buffer `kybuf' with zero
 * processing except to check for the keyboard unlock sequence.
 */
kyread()
{
  char r, x;
  char i;
  if ((* (char *) 0xF50001 & 2) == 0) return;
  i = 255 - (* (char *) 0xF00001);
  x = * (char *) 0xF40001;          // Acknowledge operation.

  if (i == 0xC2) { locked = 0; lockmark(0); }     // Unlock on sys request

  *kybufin = i;

  if (kybufin == kybuf+kybufsize-1) kybufin = kybuf;
  else kybufin++;
}

/*
 *  Blocking routine to get next key scan code from `kybuf' staging buffer.
 */
unsigned char kypoll()
{
  unsigned char r;
  while (kybufin == kybufout) kyread();
  r = *kybufout;
  if (kybufout == kybuf+kybufsize-1) kybufout = kybuf;
  else kybufout++;
  TRC(printf("out %x ", r));
  return r;
}

/*
 * Routine to install a multi-char string.
 */
char string(s, aux) char aux, *s;
{
  extendedkybd = 0;
  stringptr = s;
  auxchar = aux;
  return nsp();
}

/*
 * Routine to return next element of a multicharacter string 
 */
char nsp()
{ 
  char r;
  r = *stringptr;
  switch(r)
   {
    case '*':
      switch(*(++stringptr))
        { case 'E': r = 27; // Escape code.
              break;
          case '*': r = auxchar;
              break;
        }
      break;
  }
 if (*(++stringptr) == 0) stringptr =0;
 return r;
}


/*
 * A string with a non-printing code in it.
 */
char graphesc[] = { 29, '*', '*', 0 }


/*
 * This is the main keyboard routine which returns the next ascii character
 * from the keyboard input stream.  It blocks if hang is set.
 */
char kybdrd(hang) int hang;
{
  if (stringptr) return nsp();

  while(1)
  { 
    unsigned char x;
    int i;
    kyread();  /* Exercise input process `coroutine' */

    while (kybufin == kybufout) if (hang) kyread(); else return 0;
    x = kypoll();
    TRC(printf("kybdr %x ", x));

    /* Extended keyboard escape code logger */
    if (x == 0x70)
    {
      extendedkybd = 1;
      continue;
    }

    /* Key Up events */
    if (x == 0xF8)
    {
      unsigned char upper = kypoll();

      /* Ignore those shiftups inserted by extended kybd shifts */
      if (extendedkybd)
      {
        extendedkybd = 0;
        continue; 
      }
 
      switch(upper)
      { 
      default : continue;

      case 0xAC: case 0x89:
        shift = 0;
        continue;

      case 0x8A:
        control = 0;
        continue;

      case 0x88:
        alternate = 0;
        continue;
      }
    }


    if ((alternate & control))
    { 
      do
      {
        x = kypoll();
        printf(">%x ", x);
      } while (x != 0xAD);  /* The CR key */
      alternate = 0;
      control = 0;
      continue;
    }

    /* Special function key down codes */
    switch(x)
    {
    case 0xAC: case 0x89:
      if (extendedkybd == 0) shift = 1;
      extendedkybd = 0;
      continue;

    case 0x8A:
      if (extendedkybd == 0) control = 1;
      extendedkybd = 0;
      continue;

    case 0x88:
      if (extendedkybd == 0) alternate = 1;
      extendedkybd = 0;
      continue;

    case 0x2C:
      capslock  = 1 - (capslock & 1);
      continue;

    case 0xBB:                   // Num Lock Key
    case 0xC2:                   // Sys request key.

      sysreq(shift, control, alternate);
      continue;

    case 0xBD:  // Numeric pad 'minus' key 
      screen_toggle();     // Swap to other page
      continue;

    case 0xbf: // scroll lock / break.
      if (shift) return 255;  // Break CHAR.
      scrolllock = 1 - scrolllock;
             break;

    }


    /* Keystrokes that we wish to give special strings */


    if (extendedkybd) switch(x)
    {
    case 0x3A: // kup
       return string((shift) ? "*EOa": "*EOA");

    case 0xB9: // kdown
             return string((shift) ? "*EOb": "*EOB");
    case 0xBA: // kright
             return string((shift) ? "*EOc": "*EOC");
    case 0x35: // kleft
             return string((shift) ? "*EOd": "*EOD");

    }
    i = x;
    i = (shift) ? i+i : i+i+1;
    TRC(printf("ind %x ", i));
    x = (i & 0x100) ?  highkeys[i-256] : lowkeys[i];
    if (x == 0) continue;

    /* Extended keys */
    if (extendedkybd && x >='0' && x <= '9')
    {
      return string("*EP**", x);
    }

    /* Function keys */
    if ((x & 0xF0)==0xF0) return string("*EO**", x-(0xF0-'p'));
    if (alternate) return string(graphesc, x);
    if (capslock)
    {
      if ((x>='a') && (x<='z')) x = x - 32;
    }
    extendedkybd = 0;
    if (control && x == ' ') return string("*E@");
    return (control) ? x & 0x1F : x;
  }
}

/* end of cbg kybdr.c */


